<template>
  <div class="todo-dashboard">
    <TodoDashboardSubContainer
      header="Members"
      class="members-wrapper"
    >
      <Members
        :members="members"
        :todos="todos"
        @draft-todos="addDraftTodos"
      />
    </TodoDashboardSubContainer>
    <TodoDashboardSubContainer
      header="Draft List"
      class="draft-wrapper"
    >
      <DraftLists
        :members="members"
        :todos="draftTodosArray"
      />
    </TodoDashboardSubContainer>
  </div>
</template>

<script>
import axios from 'axios';
import Members from './Members.vue';
import DraftLists from './DraftLists.vue';
import TodoDashboardSubContainer from './TodoDashboardSubContainer.vue';

export default {
  name: 'TodoDashboard',
  components: {
    Members,
    DraftLists,
    TodoDashboardSubContainer,
  },
  data() {
    return {
      members: [],
      todos: [],
      draftTodos: {},
    };
  },
  async created() {
    try {
      await Promise.all([
        this.fetchMembers(),
        this.fetchTodos(),
      ]);
    } catch (e) {
      console.log(e);
    }
  },
  methods: {
    async fetchMembers() {
      try {
        this.members = (await axios.get('https://jsonplaceholder.typicode.com/users')).data;
      } catch (error) {
        console.log(error);
        throw error;
      }
    },
    async fetchTodos() {
      try {
        this.todos = (await axios.get('https://jsonplaceholder.typicode.com/todos')).data;
      } catch (error) {
        console.log(error);
        throw error;
      }
    },
    addDraftTodos({ id, todos }) {
      this.draftTodos[id] = todos;
      console.log(this.draftTodos);
    },
  },
  computed: {
    draftTodosArray() {
      // eslint-disable-next-line max-len
      return Object.values(this.draftTodos).reduce((todos, userTodos) => [...todos, ...userTodos], []);
    },
  },
};
</script>

<style lang="scss">
.todo-dashboard{
  overflow: hidden;
  display: flex;
  flex-flow: row nowrap;
  font-family: 'Barlow';
  width: auto;
  padding: 0 32px;
  background-color: #f2f3f3;

  .members-wrapper {
    width: 100%;
  }

  .draft-wrapper {

  }
}
</style>
